#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>
#include "led.h"
#include "keyb.h"

int readNumber(uint8_t position, uint8_t maxLength) {
	// walidacja parametrw
	if (position > 3) position = 3;
	if (maxLength > 4) maxLength = 4;
	if (position + maxLength > 4) maxLength = 4 - position;
	uint8_t dispNum = 3 - position;
	char input[5];
	uint8_t inputIndex = 0;
	uint8_t lastDigit = 0;
	while(1) {
		uint8_t key = 0;
		key = getKey();
		if (key == 15) {
			// obsuga Backspace
			if (inputIndex > 0) {
				if (lastDigit) {
					ledDispRaw(0, dispNum);
					lastDigit = 0;
				} else {
					inputIndex--;
					ledDispRaw(0, ++dispNum);
				}
			}
			continue;
		}
		if (key < 10) input[inputIndex] = '0' + key;
		if (key == 10) input[inputIndex] = '0';
		if (key == 16) {
			input[inputIndex + 1] = 0;
			break;
		}
		// wywietl cyfr
		ledDispSymbol(key < 10 ? key : 0, dispNum);
		// dla cyfr przed limitem dugoci
		if (inputIndex < maxLength - 1) {
			inputIndex++;
			if (dispNum > 0) {
				dispNum--;
			}
		} else { // dla ostatniej cyfry
			lastDigit = 1;
		}
	}
	return atoi(input);
}

uint8_t readKeyboard() {
	for (uint8_t row = 0; row < 4; row++){
		KEYB_PORT = ~_BV(row);
		_delay_us(1);
		for (uint8_t column = 0; column < 4; column++){
			if (~KEYB_PIN & _BV(column + 4)) {
				return row * 4 + column + 1;
			}
		}
	}
	return 0;
}

uint8_t getKey() {
	uint8_t key = 0;
	while (!(key = readKeyboard()));
	while (readKeyboard());
	_delay_ms(30);
	return key;
}

void keybInit() {
	KEYB_DDR = 0x0f;
}