#include <avr/io.h>
#include <util/delay.h>
#include "keyb.h"
#include "led.h"

int main(void)
{
	ledInit();
	keybInit();
	ledClear();
	uint8_t hours = readNumber(0, 2);
	uint8_t minutes = readNumber(2, 2);
	uint8_t seconds = 0;
	ledClear();
	TCCR1B = _BV(WGM12) | _BV(CS12) | _BV(CS10);
	OCR1A = 15624;
	OCR1B = 7812;
	while(1) 
	{		
		ledDispNumber(hours, "%02g", 0);
		ledDispNumber(minutes, "%02g", 2);
		while(!(TIFR & _BV(OCF1A))) {
			if(TIFR & _BV(OCF1B)) {
				TIFR |= _BV(OCF1B);
				ledTurnOnSegments(0b10000000, 2);
			}
			if(readKeyboard()) {
				while (readKeyboard());
				ledClear();
				hours = readNumber(0, 2);
				minutes = readNumber(2, 2);
			}
		}
		TIFR |= _BV(OCF1A);
		seconds++;
		if (seconds == 60) {
			seconds = 0;
			minutes++;
		}
		if (minutes == 60) {
			minutes = 0;
			hours++;
		}
		if (hours == 24) {
			hours = 0;
		}
	}
}
